// Code generated by go-swagger; DO NOT EDIT.

package boundary_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewBoundaryServiceDeleteParams creates a new BoundaryServiceDeleteParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewBoundaryServiceDeleteParams() *BoundaryServiceDeleteParams {
	return &BoundaryServiceDeleteParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewBoundaryServiceDeleteParamsWithTimeout creates a new BoundaryServiceDeleteParams object
// with the ability to set a timeout on a request.
func NewBoundaryServiceDeleteParamsWithTimeout(timeout time.Duration) *BoundaryServiceDeleteParams {
	return &BoundaryServiceDeleteParams{
		timeout: timeout,
	}
}

// NewBoundaryServiceDeleteParamsWithContext creates a new BoundaryServiceDeleteParams object
// with the ability to set a context for a request.
func NewBoundaryServiceDeleteParamsWithContext(ctx context.Context) *BoundaryServiceDeleteParams {
	return &BoundaryServiceDeleteParams{
		Context: ctx,
	}
}

// NewBoundaryServiceDeleteParamsWithHTTPClient creates a new BoundaryServiceDeleteParams object
// with the ability to set a custom HTTPClient for a request.
func NewBoundaryServiceDeleteParamsWithHTTPClient(client *http.Client) *BoundaryServiceDeleteParams {
	return &BoundaryServiceDeleteParams{
		HTTPClient: client,
	}
}

/*
BoundaryServiceDeleteParams contains all the parameters to send to the API endpoint

	for the boundary service delete operation.

	Typically these are written to a http.Request.
*/
type BoundaryServiceDeleteParams struct {

	/* ClusterID.

	   cluster_id is the id of the cluster set by user on creation.
	*/
	ClusterID string

	/* LocationOrganizationID.

	   organization_id is the id of the organization.
	*/
	LocationOrganizationID string

	/* LocationProjectID.

	   project_id is the projects id.
	*/
	LocationProjectID string

	/* LocationRegionProvider.

	   provider is the named cloud provider ("aws", "gcp", "azure").
	*/
	LocationRegionProvider *string

	/* LocationRegionRegion.

	   region is the cloud region ("us-west1", "us-east1").
	*/
	LocationRegionRegion *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the boundary service delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *BoundaryServiceDeleteParams) WithDefaults() *BoundaryServiceDeleteParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the boundary service delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *BoundaryServiceDeleteParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the boundary service delete params
func (o *BoundaryServiceDeleteParams) WithTimeout(timeout time.Duration) *BoundaryServiceDeleteParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the boundary service delete params
func (o *BoundaryServiceDeleteParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the boundary service delete params
func (o *BoundaryServiceDeleteParams) WithContext(ctx context.Context) *BoundaryServiceDeleteParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the boundary service delete params
func (o *BoundaryServiceDeleteParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the boundary service delete params
func (o *BoundaryServiceDeleteParams) WithHTTPClient(client *http.Client) *BoundaryServiceDeleteParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the boundary service delete params
func (o *BoundaryServiceDeleteParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithClusterID adds the clusterID to the boundary service delete params
func (o *BoundaryServiceDeleteParams) WithClusterID(clusterID string) *BoundaryServiceDeleteParams {
	o.SetClusterID(clusterID)
	return o
}

// SetClusterID adds the clusterId to the boundary service delete params
func (o *BoundaryServiceDeleteParams) SetClusterID(clusterID string) {
	o.ClusterID = clusterID
}

// WithLocationOrganizationID adds the locationOrganizationID to the boundary service delete params
func (o *BoundaryServiceDeleteParams) WithLocationOrganizationID(locationOrganizationID string) *BoundaryServiceDeleteParams {
	o.SetLocationOrganizationID(locationOrganizationID)
	return o
}

// SetLocationOrganizationID adds the locationOrganizationId to the boundary service delete params
func (o *BoundaryServiceDeleteParams) SetLocationOrganizationID(locationOrganizationID string) {
	o.LocationOrganizationID = locationOrganizationID
}

// WithLocationProjectID adds the locationProjectID to the boundary service delete params
func (o *BoundaryServiceDeleteParams) WithLocationProjectID(locationProjectID string) *BoundaryServiceDeleteParams {
	o.SetLocationProjectID(locationProjectID)
	return o
}

// SetLocationProjectID adds the locationProjectId to the boundary service delete params
func (o *BoundaryServiceDeleteParams) SetLocationProjectID(locationProjectID string) {
	o.LocationProjectID = locationProjectID
}

// WithLocationRegionProvider adds the locationRegionProvider to the boundary service delete params
func (o *BoundaryServiceDeleteParams) WithLocationRegionProvider(locationRegionProvider *string) *BoundaryServiceDeleteParams {
	o.SetLocationRegionProvider(locationRegionProvider)
	return o
}

// SetLocationRegionProvider adds the locationRegionProvider to the boundary service delete params
func (o *BoundaryServiceDeleteParams) SetLocationRegionProvider(locationRegionProvider *string) {
	o.LocationRegionProvider = locationRegionProvider
}

// WithLocationRegionRegion adds the locationRegionRegion to the boundary service delete params
func (o *BoundaryServiceDeleteParams) WithLocationRegionRegion(locationRegionRegion *string) *BoundaryServiceDeleteParams {
	o.SetLocationRegionRegion(locationRegionRegion)
	return o
}

// SetLocationRegionRegion adds the locationRegionRegion to the boundary service delete params
func (o *BoundaryServiceDeleteParams) SetLocationRegionRegion(locationRegionRegion *string) {
	o.LocationRegionRegion = locationRegionRegion
}

// WriteToRequest writes these params to a swagger request
func (o *BoundaryServiceDeleteParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param cluster_id
	if err := r.SetPathParam("cluster_id", o.ClusterID); err != nil {
		return err
	}

	// path param location.organization_id
	if err := r.SetPathParam("location.organization_id", o.LocationOrganizationID); err != nil {
		return err
	}

	// path param location.project_id
	if err := r.SetPathParam("location.project_id", o.LocationProjectID); err != nil {
		return err
	}

	if o.LocationRegionProvider != nil {

		// query param location.region.provider
		var qrLocationRegionProvider string

		if o.LocationRegionProvider != nil {
			qrLocationRegionProvider = *o.LocationRegionProvider
		}
		qLocationRegionProvider := qrLocationRegionProvider
		if qLocationRegionProvider != "" {

			if err := r.SetQueryParam("location.region.provider", qLocationRegionProvider); err != nil {
				return err
			}
		}
	}

	if o.LocationRegionRegion != nil {

		// query param location.region.region
		var qrLocationRegionRegion string

		if o.LocationRegionRegion != nil {
			qrLocationRegionRegion = *o.LocationRegionRegion
		}
		qLocationRegionRegion := qrLocationRegionRegion
		if qLocationRegionRegion != "" {

			if err := r.SetQueryParam("location.region.region", qLocationRegionRegion); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
