// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	cloud "github.com/hashicorp/hcp-sdk-go/clients/cloud-shared/v1/models"
)

// HashicorpCloudVagrant20220930UpdateBoxResponse hashicorp cloud vagrant 20220930 update box response
//
// swagger:model hashicorp.cloud.vagrant_20220930.UpdateBoxResponse
type HashicorpCloudVagrant20220930UpdateBoxResponse struct {

	// The updated Box.
	Box *HashicorpCloudVagrant20220930Box `json:"box,omitempty"`

	// The operation associated with the box update, if any was needed. This can
	// be used to monitor the progress of background tasks related to the update
	// of this box.
	//
	// If this field is empty, there is no operation associated with this update
	// and the box should be available immediately.
	Operation *cloud.HashicorpCloudOperationOperation `json:"operation,omitempty"`
}

// Validate validates this hashicorp cloud vagrant 20220930 update box response
func (m *HashicorpCloudVagrant20220930UpdateBoxResponse) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateBox(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateOperation(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *HashicorpCloudVagrant20220930UpdateBoxResponse) validateBox(formats strfmt.Registry) error {
	if swag.IsZero(m.Box) { // not required
		return nil
	}

	if m.Box != nil {
		if err := m.Box.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("box")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("box")
			}
			return err
		}
	}

	return nil
}

func (m *HashicorpCloudVagrant20220930UpdateBoxResponse) validateOperation(formats strfmt.Registry) error {
	if swag.IsZero(m.Operation) { // not required
		return nil
	}

	if m.Operation != nil {
		if err := m.Operation.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("operation")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("operation")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this hashicorp cloud vagrant 20220930 update box response based on the context it is used
func (m *HashicorpCloudVagrant20220930UpdateBoxResponse) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateBox(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateOperation(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *HashicorpCloudVagrant20220930UpdateBoxResponse) contextValidateBox(ctx context.Context, formats strfmt.Registry) error {

	if m.Box != nil {

		if swag.IsZero(m.Box) { // not required
			return nil
		}

		if err := m.Box.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("box")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("box")
			}
			return err
		}
	}

	return nil
}

func (m *HashicorpCloudVagrant20220930UpdateBoxResponse) contextValidateOperation(ctx context.Context, formats strfmt.Registry) error {

	if m.Operation != nil {

		if swag.IsZero(m.Operation) { // not required
			return nil
		}

		if err := m.Operation.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("operation")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("operation")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *HashicorpCloudVagrant20220930UpdateBoxResponse) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *HashicorpCloudVagrant20220930UpdateBoxResponse) UnmarshalBinary(b []byte) error {
	var res HashicorpCloudVagrant20220930UpdateBoxResponse
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
