// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewListGcpDynamicSecretsParams creates a new ListGcpDynamicSecretsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewListGcpDynamicSecretsParams() *ListGcpDynamicSecretsParams {
	return &ListGcpDynamicSecretsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewListGcpDynamicSecretsParamsWithTimeout creates a new ListGcpDynamicSecretsParams object
// with the ability to set a timeout on a request.
func NewListGcpDynamicSecretsParamsWithTimeout(timeout time.Duration) *ListGcpDynamicSecretsParams {
	return &ListGcpDynamicSecretsParams{
		timeout: timeout,
	}
}

// NewListGcpDynamicSecretsParamsWithContext creates a new ListGcpDynamicSecretsParams object
// with the ability to set a context for a request.
func NewListGcpDynamicSecretsParamsWithContext(ctx context.Context) *ListGcpDynamicSecretsParams {
	return &ListGcpDynamicSecretsParams{
		Context: ctx,
	}
}

// NewListGcpDynamicSecretsParamsWithHTTPClient creates a new ListGcpDynamicSecretsParams object
// with the ability to set a custom HTTPClient for a request.
func NewListGcpDynamicSecretsParamsWithHTTPClient(client *http.Client) *ListGcpDynamicSecretsParams {
	return &ListGcpDynamicSecretsParams{
		HTTPClient: client,
	}
}

/*
ListGcpDynamicSecretsParams contains all the parameters to send to the API endpoint

	for the list gcp dynamic secrets operation.

	Typically these are written to a http.Request.
*/
type ListGcpDynamicSecretsParams struct {

	// AppName.
	AppName string

	// OrganizationID.
	OrganizationID string

	// ProjectID.
	ProjectID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the list gcp dynamic secrets params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ListGcpDynamicSecretsParams) WithDefaults() *ListGcpDynamicSecretsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the list gcp dynamic secrets params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ListGcpDynamicSecretsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the list gcp dynamic secrets params
func (o *ListGcpDynamicSecretsParams) WithTimeout(timeout time.Duration) *ListGcpDynamicSecretsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the list gcp dynamic secrets params
func (o *ListGcpDynamicSecretsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the list gcp dynamic secrets params
func (o *ListGcpDynamicSecretsParams) WithContext(ctx context.Context) *ListGcpDynamicSecretsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the list gcp dynamic secrets params
func (o *ListGcpDynamicSecretsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the list gcp dynamic secrets params
func (o *ListGcpDynamicSecretsParams) WithHTTPClient(client *http.Client) *ListGcpDynamicSecretsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the list gcp dynamic secrets params
func (o *ListGcpDynamicSecretsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAppName adds the appName to the list gcp dynamic secrets params
func (o *ListGcpDynamicSecretsParams) WithAppName(appName string) *ListGcpDynamicSecretsParams {
	o.SetAppName(appName)
	return o
}

// SetAppName adds the appName to the list gcp dynamic secrets params
func (o *ListGcpDynamicSecretsParams) SetAppName(appName string) {
	o.AppName = appName
}

// WithOrganizationID adds the organizationID to the list gcp dynamic secrets params
func (o *ListGcpDynamicSecretsParams) WithOrganizationID(organizationID string) *ListGcpDynamicSecretsParams {
	o.SetOrganizationID(organizationID)
	return o
}

// SetOrganizationID adds the organizationId to the list gcp dynamic secrets params
func (o *ListGcpDynamicSecretsParams) SetOrganizationID(organizationID string) {
	o.OrganizationID = organizationID
}

// WithProjectID adds the projectID to the list gcp dynamic secrets params
func (o *ListGcpDynamicSecretsParams) WithProjectID(projectID string) *ListGcpDynamicSecretsParams {
	o.SetProjectID(projectID)
	return o
}

// SetProjectID adds the projectId to the list gcp dynamic secrets params
func (o *ListGcpDynamicSecretsParams) SetProjectID(projectID string) {
	o.ProjectID = projectID
}

// WriteToRequest writes these params to a swagger request
func (o *ListGcpDynamicSecretsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param app_name
	if err := r.SetPathParam("app_name", o.AppName); err != nil {
		return err
	}

	// path param organization_id
	if err := r.SetPathParam("organization_id", o.OrganizationID); err != nil {
		return err
	}

	// path param project_id
	if err := r.SetPathParam("project_id", o.ProjectID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
